#!/bin/sh
#bilan.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  Author  : davidlucardi@aol.com
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002 modification : 06/08/2003
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source tableaux.conf

set didacticiel ""
source msg.tcl

# pour chaque didacticiel/module/difficulte faire une sentinelle
foreach didacticiel $glob(didacticiels) {
  for { set i 0 } { $i <= 5 } { incr i } {
    for { set j -1 } { $j <= 5 } { incr j } {
      set lt_array($didacticiel,$i,$j,duree) 0
      set lt_array($didacticiel,$i,$j,reussite) 0
      set lt_array($didacticiel,$i,$j,nbtours) 0
    }
  }
}
# les sentinelles sont en place

. configure -width 640 -height 480
wm geometry . +0+0
wm title . [mc {bilan}]

#frame pour les boutons de choix : lve classe tous
frame .top -borderwidth 10
pack .top -side top -fill x

#crer les boutons
button .top.but_eleve -text [mc {eleve}] -command bilan_eleve
button .top.but_classe -text [mc {classe}] -command bilan_classe
button .top.but_tous -text [mc {tous}] -command bilan_tous 
pack .top.but_eleve .top.but_classe .top.but_tous -side left


set bg #ffff80

frame .t
text .t.text -yscrollcommand {.t.scroll set} -setgrid true \
	-width 80 -height 40 -wrap word -background $bg
scrollbar .t.scroll -command {.t.text yview}
pack .t.scroll -side right -fill y
pack .t.text -side left -fill both -expand true
pack .t -side top -fill both -expand true

frame .b
pack .b -side bottom -fill x


############################################################
proc bilan_eleve {} {
  global glob lt_array didacticiel

  cd $glob(trace_dir)
  set types {
	{"Catgories"		{.log}	}
  }
  catch {set file [tk_getOpenFile -filetypes $types]}
  if {[catch { set f [open [file join $file] "r" ] }] } {
	set answer [tk_messageBox -message [mc {errfichier}] -type ok -icon info] 
	exit
  }

  # lire les parcours et rsulats de l'lve 

  while {![eof $f]} {
    set ligne [gets $f]
    if { [string length $ligne] > 0 } {
      set nom [lindex $ligne 0]
      set classe [lindex $ligne 1]
    }
    set tmp_date [lindex $ligne 2]
    set duree [lindex $ligne 3]
    set didacticiel [lindex [lindex $ligne 4] 0]
    set module [lindex [lindex $ligne 4] 1]
    set difficulte [lindex [lindex $ligne 4] 2]
    set version [lindex $ligne 5]
    if { [lindex [lindex $ligne 6] 0] == [lindex [lindex $ligne 6] 1] } {
      set reussite 1
    } else {
      set reussite 0
    }
    if { $didacticiel != ""} {
      incr lt_array($didacticiel,$module,$difficulte,duree) [expr 0+$duree]
      incr lt_array($didacticiel,$module,$difficulte,reussite) [expr 0+$reussite]
      incr lt_array($didacticiel,$module,$difficulte,nbtours)

      incr lt_array($didacticiel,$module,5,duree) [expr 0+$duree]
      incr lt_array($didacticiel,$module,5,reussite) [expr 0+$reussite]
      incr lt_array($didacticiel,$module,5,nbtours)

      incr lt_array($didacticiel,5,$difficulte,duree) [expr 0+$duree]
      incr lt_array($didacticiel,5,$difficulte,reussite) [expr 0+$reussite]
      incr lt_array($didacticiel,5,$difficulte,nbtours)

      incr lt_array($didacticiel,5,5,duree) [expr 0+$duree]
      incr lt_array($didacticiel,5,5,reussite) [expr 0+$reussite]
      incr lt_array($didacticiel,5,5,nbtours)
    }
  }
  close $f

  # #######################################################
  # les rsultats sont maintenant dans le tableau lt_array
  # quels traitements ?
  # #######################################################

  set fnom "$glob(trace_dir)/bilan.$nom"
  set f [open $fnom w]
  puts $f "[mc {bilan}] : $nom - [mc {classe}] : $classe"

  puts $f "\n\n[mc {reussite_echec}]"
  puts $f "+----------------------------------------------------------------------+"
  puts $f [format "didacticiel niv| %5d | %5d | %5d | %5d | %5d | %5d | %5d |" \
              -1 0 1 2 3 4 5 ]
  puts $f "+----------------------------------------------------------------------+"
  foreach didacticiel $glob(didacticiels) {
    for { set i 0 } { $i <= 4 } { incr i } {
      set line "$didacticiel $i : "
      for { set j -1 } { $j <= 5 } { incr j } {
        if { $lt_array($didacticiel,$i,$j,nbtours)> 0 } {
          if { $lt_array($didacticiel,$i,$j,reussite) == $lt_array($didacticiel,$i,$j,nbtours) } {
            set s($j) "+"
          } else {
            set s($j) "-"
          }
        } else {
          set s($j) " "
        }
      }
      if { $lt_array($didacticiel,$i,5,nbtours) >0 } {
        puts $f [format "%-9s : %2d | %5s | %5s | %5s | %5s | %5s | %5s | %5s |" \
          $didacticiel $i $s(-1) $s(0) $s(1) $s(2) $s(3) $s(4) $s(5)]
      }
    }
    if { $lt_array($didacticiel,5,5,nbtours) > 0 } {
      puts $f "+----------------------------------------------------------------------+"
    }
  }

  puts $f "\n\n[mc {pourcent_reussite}]"
  puts $f "+----------------------------------------------------------------------+"
  puts $f [format "didacticiel niv| %5d | %5d | %5d | %5d | %5d | %5d | %5d |" \
              -1 0 1 2 3 4 5 ]
  puts $f "+----------------------------------------------------------------------+"
  foreach didacticiel $glob(didacticiels) {
    for { set i 0 } { $i <= 5 } { incr i } {
      set line "$didacticiel $i : "
      for { set j -1 } { $j <= 5 } { incr j } {
        if { $lt_array($didacticiel,$i,$j,nbtours)> 0 } {
          set v($j) [expr 100*$lt_array($didacticiel,$i,$j,reussite)/$lt_array($didacticiel,$i,$j,nbtours)]
        } else {
          set v($j) 0
        }
      }
      if { $lt_array($didacticiel,$i,5,nbtours) >0 } {
        puts $f [format "%-9s : %2d | %5d | %5d | %5d | %5d | %5d | %5d | %5d |" \
          $didacticiel $i $v(-1) $v(0) $v(1) $v(2) $v(3) $v(4) $v(5)]
      }
    }
    if { $lt_array($didacticiel,5,5,nbtours) > 0 } {
      puts $f "+----------------------------------------------------------------------+"
    }
  }

  puts $f "\n\n[mc {duree_moyenne}]"
  puts $f "+----------------------------------------------------------------------+"
  puts $f [format "didacticiel niv| %5d | %5d | %5d | %5d | %5d | %5d | %5d |" \
              -1 0 1 2 3 4 5 ]
  puts $f "+----------------------------------------------------------------------+"
  foreach didacticiel $glob(didacticiels) {
    for { set i 0 } { $i <= 5 } { incr i } {
      set line "$didacticiel $i : "
      for { set j -1 } { $j <= 5 } { incr j } {
        if { $lt_array($didacticiel,$i,$j,nbtours)> 0 } {
          set v($j) [expr 1.0*$lt_array($didacticiel,$i,$j,duree)/$lt_array($didacticiel,$i,$j,nbtours)]
        } else {
          set v($j) 0
        }
      }
      if { $lt_array($didacticiel,$i,5,nbtours) >0 } {
        puts $f [format "%-9s : %2d | %5.1f | %5.1f | %5.1f | %5.1f | %5.1f | %5.1f | %5.1f |" \
          $didacticiel $i $v(-1) $v(0) $v(1) $v(2) $v(3) $v(4) $v(5)]
      }
    }
    if { $lt_array($didacticiel,5,5,nbtours) > 0 } {
      puts $f "+----------------------------------------------------------------------+"
    }
  }

  close $f

  #le fichier est sauvegard dans $glob(trace_dir)/bilan.nom_eleve

  # maintenant, on affiche
#  set $f [open "$glob(trace_dir)/bilan.$nom" r]
  set f [open $fnom r]
  while { ! [eof $f] } {
    set line [gets $f]
    .t.text insert end $line\n
    .t.text see end
  }
  close $f

  .t.text insert end "\n[mc {bilan_sauve}] $glob(trace_dir)/bilan.$nom\n\n"
  .t.text see end

  .t.text insert end "[mc {effacer_fichier}] $glob(trace_dir)/bilan.$nom ?"
  .t.text insert end { OUI } tagoui { NON } tagnon
  set bold "-background #43ce80 -relief raised -borderwidth 5"
  set normal "-background #ffff80 -relief flat"
  foreach tag { tagoui tagnon } {
    .t.text tag bind $tag <Any-Enter> ".t.text tag configure $tag $bold"
    .t.text tag bind $tag <Any-Leave> ".t.text tag configure $tag $normal"
  }
  .t.text tag bind tagoui <1> "effacer_trace_eleve $f $fnom; break"
  .t.text tag bind tagnon <1> "retour_sans_effacer $f $fnom; break"

} ;# fin bilan_eleve

proc effacer_trace_eleve { f fnom } {
  exec rm $f
  .t.text insert end "\n=> $fnom effac.\n\n"
  .t.text see end
  .t.text tag delete tagoui tagnon
}
proc retour_sans_effacer { f fnom } {
  .t.text insert end "\n=> $fnom non effac.\n\n"
  .t.text see end
  .t.text tag delete tagoui tagnon
}

###################################################################################

proc bilan_classe {} {
  .t.text insert end "\n\nBilan classe : [mc {non_implante}].\n\n"
}

proc bilan_tous {} {
  .t.text insert end "\n\nBilan tous les lves : [mc {non_implante}].\n\n"
}
