#!/bin/sh
#tableau0.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  Author  : davidlucardi@aol.com
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002 Modification : 06/08/2003
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

set didacticiel [lindex $argv 0]
set difficulte [lindex $argv 1]

source tableaux.conf
source msg.tcl

if { $glob(platform) == "windows" } {
  set f [open [file join $glob(home_tableaux) Reglages trace_user] "r"]
  set glob(trace_user) [gets $f]
  close $f
}

# Dcommenter la ligne suivante si Img est installe
# package require Img

########################### On cre la fentre principale###########################

# placement de la fentre en haut et  gauche de l'cran

. configure -bg $glob(bgcolor)
wm geometry . +110+0

frame .frame -width $glob(width) -height $glob(height) -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes


# #######################On cre un canvas###########################################
# charg d'accueillir les sorties graphiques,
# qui peuvent tre des images, des textes, des formes gomtriques ...

set c .frame.c
canvas $c -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $c -expand true 

image create photo gros$didacticiel -file [file join $didacticiel gros$didacticiel.gif]

################################################
# ###
# recule
# ###
proc recule {} {
  global difficulte
  if { $difficulte > 0 } {
    incr difficulte -1 
  }
}
# ###
# avance
# ###
proc avance {} {
  global glob didacticiel difficulte

  # dterminer les difficults max

  #lecture du parcours de l'lve
    #lire le fichier utilisateur
    set f [open [file join  $glob(trace_user).level] "r"]
    while { ! [eof $f] } {
      set line [gets $f]
      set lt_array([lindex $line 0]) [lrange $line 1 end] 
    }
    close $f
    #traiter le didacticiel
    for {set i 0} {$i <= 4} {incr i 1} {
      set parcours($i) [lindex $lt_array($didacticiel) $i]
    }

  #autoriser/interdire
  for { set i 0 } { $i < 4 } { incr i } {
    set ktmp [expr $parcours($i) + 1]
    if { $ktmp < 4 } {
      set difficulte_max($i) $ktmp
    } else {
      set difficulte_max($i) 4
    }
  }
  if { [expr $parcours(2)+$parcours(3) ] < 4 } {
    set difficulte_max(4) -1
  } else {
    set difficulte_max(4) 4
  }

  if { $difficulte < $difficulte_max(0) } {
    incr difficulte
  }
}


# ###
# lire le fichier tableau de jeu
# ###
proc lire_tableau {} {
  global didacticiel taillerect imgperso globcol globrow  imgarr
  set f [open [file join $didacticiel tableau.jeu] "r"]
  set taillerect [gets $f]
  set imgperso [gets $f]
  set r [expr int(rand()*2)]
  if { $r == 0 } {
    set globcol [gets $f]
    for {set i 1} {$i <= $globcol} {incr i 1} {
      set imgarr(0,$i) [gets $f]
    }
    set globrow [gets $f]
    for {set i 1} {$i <= $globrow} {incr i 1} {
      set imgarr($i,0) [gets $f]
    }
    for { set i 1 } { $i <= $globrow } {incr i 1 } {
      for { set j 1 } { $j <= $globcol } {incr j 1 } {
        set imgarr($i,$j) [gets $f]
      }
    }
  } else {
    set globrow [gets $f]
    for {set i 1} {$i <= $globrow} {incr i 1} {
      set imgarr($i,0) [gets $f]
    }
    set globcol [gets $f]
    for {set i 1} {$i <= $globcol} {incr i 1} {
      set imgarr(0,$i) [gets $f]
    }
    for { set i 1 } { $i <= $globcol } {incr i 1 } {
      for { set j 1 } { $j <= $globrow } {incr j 1 } {
        set imgarr($j,$i) [gets $f]
      }
    }
  }
  close $f 
}

# ###
# permuter les images
# ###
proc permuter_images {} {
  global imgperso difficulte globcol globrow nbcol nbrow imgarr
  # permuter les lignes
  for {set i 1} {$i <= $globrow} {incr i 1} {
    set k [expr int(rand()*$globrow)+1]
    for { set j 0 } {$j <= $globcol } { incr j } {
      set imgtmp $imgarr($i,$j)
      set imgarr($i,$j) $imgarr($k,$j)
      set imgarr($k,$j) $imgtmp
    } 
  }
  # permuter les colonnes
  for {set i 1} {$i <= $globcol} {incr i 1} {
    set k [expr int(rand()*$globcol)+1]
    for { set j 0 } {$j <= $globrow } { incr j } {
      set imgtmp $imgarr($j,$i)
      set imgarr($j,$i) $imgarr($j,$k)
      set imgarr($j,$k) $imgtmp
    } 
  }
  
  #instancier nbcol et nbrow
  if     { $difficulte == "0" } { 
    set nbrow 3 ; set nbcol 1 
  } elseif { $difficulte == "1" } { 
   set nbrow 1 ; set nbcol 4 
  } elseif { $difficulte == "2" } {
   set nbrow 2 ; set nbcol 2 
  } elseif { $difficulte == "3" } {
   set nbrow 3 ; set nbcol 3 
  } elseif { $difficulte == "4" } {
   set nbrow 3 ; set nbcol 4 
  }

  if {$nbrow> $globrow} {
    set nbrow $globrow
  }
  if {$nbcol> $globcol} {
    set nbcol $globcol
  }
}

# ##
# sauver trace-lve et parcours
# ##
proc sauver_trace_parcours {} {
  global glob didacticiel difficulte nbessais nbrow nbcol heure_debut

  ## trace
  # utilisateur/classedate/dure/didacticiel/niveau/difficulte/version/nbessais/nbquestions
  set eleve [lindex [split $glob(trace_user) /] end]
  if { $glob(platform) == "unix" } {
    set heure_fin [clock clicks -milliseconds]
    set duree [expr abs(int($heure_debut-$heure_fin)/1000)]
    set date_heure [clock format [clock seconds] -format "%c"]
    set trace_eleve "$eleve classe \{$date_heure\} $duree \{$didacticiel 0 $difficulte\} $glob(version)"
  } else {
    set trace_eleve "$eleve classe \{Ddd Mmm  99 00:00:00 9999\} 0 \{$didacticiel 0 $difficulte\} $glob(version)"
  }
  lappend trace_eleve "$nbessais [expr $nbrow*$nbcol]"

  set f [open [file join $glob(trace_user).log] "a+"]
  puts $f $trace_eleve
  close $f

  ## parcours
  # bug Tcl/Tk ? Ne peut utiliser w+. Ouvrir r puis w et renommer
  #lire les parcours en lecture
  set lt_array($didacticiel) "-1 -1 -1 -1 -1" ;#sentinelle
  set f [open [file join $glob(trace_user).level] "r"]
  while { ! [eof $f] } {
    set line [gets $f]
    set lt_array([lindex $line 0]) [lrange $line 1 end]
  }
  close $f

  set parcours [lindex $lt_array($didacticiel) 0]

  #parcours suffisant ? Tolrance : 0 ou 1 erreur
  if { $parcours < $difficulte && $nbessais <= [expr $nbrow*$nbcol + 1 ] } {
    set lt_array($didacticiel) [lreplace $lt_array($didacticiel) 0 0 $difficulte]
    #sauver dans fichier temporaire
    set f [open [file join $glob(trace_user).tmp] "w"]
    foreach local_didacticiel [array names lt_array] {
      puts $f "$local_didacticiel $lt_array($local_didacticiel)"
    }
    close $f
    #renommer
    file rename -force $glob(trace_user).tmp $glob(trace_user).level 
  }
}

proc generelisteforme {} {
  global listeforme nbcol nbrow
  set listeforme ""
  for {set i 1} {$i <= $nbcol} {incr i 1} {
    for {set j 1} {$j <= $nbrow} {incr j 1} {
      lappend listeforme $i\040$j
    }
  }
  for {set i 1} {$i < [expr 2*$nbcol*$nbrow]} {incr i 1} {
    set t1 [expr int(rand()*$nbcol*$nbrow)]
    set t2 [expr int(rand()*$nbcol*$nbrow)]
    set tmp [lindex $listeforme $t1]
    set listeforme [lreplace $listeforme $t1 $t1 [lindex $listeforme $t2]]
    set listeforme [lreplace $listeforme $t2 $t2 $tmp]
  }
}

# #################################################################################
# frame en bas avec boutons 'continuer', flches gauche et droite, le score et une tiquette de controle de la rponse

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true
label .bframe.lab2 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab2 -column 1 -padx 68 -row 1
button .bframe.but_gauche -image \
  [image create photo fgauche -file [file join sysdata fgauche.gif]] -command "recule; commence $c; main $c"
grid .bframe.but_gauche -column 2 -row 1
button .bframe.next -image [image create photo imagbut -file [file join sysdata again2.gif]] -command "commence $c; main $c"
grid .bframe.next -column 3 -padx 10 -row 1
button .bframe.but_droite -image \
  [image create photo fdroite -file [file join sysdata fdroite.gif]] -command "avance; commence $c; main $c"
grid .bframe.but_droite -column 4  -row 1


# #################################################################################
# commence, appele depuis le bouton 'recommencer' cad 'next'

# #######################Initialisation de variables###############################
# nbcol : nombre de colonnes du tableau
# nbrow : nombre de lignes 
# taillerect : taille d'une cellule du tableau 
# on peut modifier le nb de lignes ou de colonnes du tableau, en tenant compte de la taille de la fentre
# en jouant sur la taille des cellules, en redimensionnant les images, en crant d'autres images
# si l'on cre d'autres lignes ou colonnes
# indice1 et indice2 : numro des habits tirs au hasard
# on rcupre les params du fichier tableau.jeu et on le mmorise dans les variables imgperso,imgarr
# respectivement le personnage, les images de la ligne d'entte et de la colonne d'entte

proc commence {c} {
  global glob didacticiel difficulte nbcol nbrow taillerect indice1 indice2 imgarr imgperso \
	listeforme compt nbessais listeval heure_debut
  $c delete all
  wm title . "$didacticiel $difficulte"
  
  lire_tableau
  permuter_images

  ####################################################################

  set nbessais 0
  set compt 0

  generelisteforme

  ####################Cration du tableau###################################
  # On utilise des rectangles pour dessiner les cases, on aurait pu utiliser des lignes
  # De mme, on aurait pu utiliser le 'grid manager' pour grer le tout, mais c'aurait t peut tre
  # un peu plus compliqu. L'avantage des rectangles, c'est qu'ils peuvent constituer des objets
  # indpendants, utile si on veut leur associer des comportements

  for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
    for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
      $c create rect [expr $glob(org) + $i*$taillerect] [expr $glob(org) + $j*$taillerect ]  [expr $glob(org) + ($i+1)*$taillerect]  [expr $glob(org) + ($j+1)*$taillerect]  -width 2 -fill gray -tags rect$i$j
    }
  }

  ##################### placement des images de la ligne 0 et de la colonne 0########

  for {set i 1} {$i <= [expr $nbcol]} {incr i 1} {
    $c create image [expr $glob(org) + $i*$taillerect + int($taillerect/2)] [expr $glob(org) + int($taillerect/2) ] \
	-image [image create photo -file [file join $didacticiel $imgarr($i,0)]]
  }

  for {set j 1} {$j <= [expr $nbrow]} {incr j 1} {
    $c create image [expr $glob(org) + int($taillerect/2) ] [expr $glob(org) + $j*$taillerect + int($taillerect/2)] \
	-image [image create photo -file [file join $didacticiel $imgarr(0,$j)]]
  }

  # fond clignotant dans la case (0,0)
  $c create image [expr $glob(org) + int($taillerect/2)] [expr $glob(org) + int($taillerect/2)] \
	-image [image create photo -file [file join sysdata cellule00.gif]]


  if { $glob(platform) == "unix" } {
    set heure_debut [clock clicks -milliseconds]
  } else {
    set heure_debut 0
  }
}

##########################################################
proc main {c} {
  global glob didacticiel nbcol nbrow taillerect indice1 indice2  \
      imgarr imgperso listeforme compt nbessais

  .bframe.next configure -state disabled
  .bframe.lab2 configure -text [mc {move_it}] 
  grid .bframe.lab2 -padx 8 

  ####################Cration du personnage#####################
  # Nous ne sommes pas limits  ce genre de situations : on peut trs bien crer
  # des images reprsentant des lettres ou des syllabes ...
  # Initialisation de 2 variables alatoires pour le choix de la tenue vestimentaire
  set indice1 [lindex [lindex $listeforme $compt] 0]
  set indice2 [lindex [lindex $listeforme $compt] 1]

  # A cette image, on associe le tag 'drag' permettant de la reconnatre plus tard
  # pour la dplacer. 

  image create photo forme$compt
  $c create image 60 60 -image forme$compt -tag drag
  forme$compt read [file join $didacticiel $imgarr($indice1,$indice2)]

  #####################################Gestion des vnements############################
  # On associe la gestion des dplacements avec l'item portant le tag 'drag'
  # %x %y rcuprent la position de la souris.  

  $c bind drag <ButtonRelease-1> "itemStopDrag $c %x %y"
  $c bind drag <1> "itemStartDrag $c %x %y"
  $c bind drag <B1-Motion> "itemDrag $c %x %y"
  bind . <Destroy> "exit"
}



# ############################Lorsque l'on clique sur le personnage (bouton appuy)
# On capture la position de la souris dans les variables lastX et lastY
# de mme que les coordonnes du personnage 'sourcecoord'

proc itemStartDrag {c x y} {
  global lastX lastY sourcecoord
  set sourcecoord [$c coords current]
  set lastX [$c canvasx $x]
  set lastY [$c canvasy $y]
  . config -cursor fleur
}

# #########################On relche la souris.
# C'est ici que l'on fait le traitement et l'analyse de la position du personnage
# Lorsque le traitement sera plus important, on pourra crer une ou plusieurs procdures
# supplmentaires pour grer les essais, les erreurs, le rebouclage, etc.

proc itemStopDrag {c x y} {
  global glob didacticiel taillerect nbrow nbcol sourcecoord indice1 indice2 compt nbessais listeval
  incr nbessais

  . config -cursor left_ptr

  set coord [$c coords current]
  #On calcule le numro de la case o se trouve le personnage (xc et yc)
  set xc [expr int([lindex $coord 0]/$taillerect)]
  set yc [expr int([lindex $coord 1]/$taillerect)]
  # On teste si le personnage est dans une case valide

  if {$xc==$indice1 && $yc==$indice2} {
    # Si oui, on dplace le personnage             
      set i [$c find withtag drag] 
      $c coords $i [expr $xc*$taillerect + int($taillerect/2)] [expr $yc*$taillerect + int($taillerect/2)]
      $c itemconf $i -tag dead
    
    set str "[mc {win}]. $nbessais [mc {sets}]."
    .bframe.lab2 configure -text $str
    grid .bframe.lab2 -padx 16 

    if {[incr compt] < [expr $nbcol*$nbrow]} {
      main $c 
    } else {
      .bframe.next configure -state normal
      sauver_trace_parcours
      $c create image [expr int($glob(width)/2)] [expr int($glob(height)/2)] -image gros$didacticiel

      return 
    } 
  } else {
    # gestion des erreurs
    bell
    set i [$c find withtag drag]
    $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
  }
}

# ##################Dplacement du personnage, gestion des coordonnes avec lastX et lastY
proc itemDrag {c x y} {
  global lastX lastY
  set x [$c canvasx $x]
  set y [$c canvasy $y]
  # On deplace le tag 'drag'
  $c move drag [expr $x-$lastX] [expr $y-$lastY]
  set lastX $x
  set lastY $y
}

##################################################################"
# appel de la procdure principale
commence $c
main $c
