#!/bin/sh
#tableau3.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  Author  : davidlucardi@aol.com
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002 modification : 06/08/2003
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

set didacticiel [lindex $argv 0]
set difficulte [lindex $argv 1]

source tableaux.conf
source msg.tcl

if { $glob(platform) == "windows" } {
  set f [open [file join $glob(home_tableaux) Reglages trace_user] "r"]
  set glob(trace_user) [gets $f]
  close $f
}

# Dcommenter la ligne suivante si Img est installe
#package require Img

# nbquestions : nbre de questions  poser
# iquestion : numro de la question courante
# nbessai : nbre d'essais pour rpondre  une question
# nbjustes : nbre de rponses justes
#set nbessai 0
#set iquestion 0
set nbquestions 5
#set nbjustes 0

########################### On cre la fentre principale###########################

# placement de la fentre en haut et  gauche de l'cran

. configure -bg $glob(bgcolor)
wm geometry . +0+0

frame .frame -width $glob(width) -height $glob(height) -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes

########################On cre un canvas###########################################
# charg d'accueillir les sorties graphiques,
# qui peuvent tre des images, des textes, des formes gomtriques ...

set c .frame.c
canvas $c -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $c -expand true 

# on cre une frame en bas en avant-dernire ligne avec
#   le score affich sous forme de ttes (bien passable mal)
#   un bouton 'continuer'

frame .bframe -bg $glob(bgcolor)
pack .bframe -side top -expand true

  image create photo pbien -file [file join sysdata pbien.gif] 
  image create photo ppass -file [file join sysdata ppass.gif]
  image create photo pmal -file [file join sysdata pmal.gif]
  image create photo pneutre -file [file join sysdata pneutre.gif]

  image create photo gros$didacticiel -file [file join $didacticiel gros$didacticiel.gif]

for {set i 1} {$i <= $nbquestions} {incr i 1} {
  label .bframe.lab$i -bg $glob(bgcolor) -width 4
  grid .bframe.lab$i -column [expr $i -1] -row 1 -sticky e
  .bframe.lab$i configure -image pneutre -width 40
}

button .bframe.but_gauche -image \
  [image create photo fgauche -file [file join sysdata fgauche.gif]] -command "recule; commence $c"
grid .bframe.but_gauche -column [expr $nbquestions + 1] -row 1
button .bframe.next -image \
	[image create photo -file [file join sysdata again2.gif]] \
	-command "commence $c"
grid .bframe.next -column [expr $nbquestions + 2] -row 1
button .bframe.but_droite -image \
  [image create photo fdroite -file [file join sysdata fdroite.gif]] -command "avance; commence $c"
grid .bframe.but_droite -column [expr $nbquestions + 3]  -row 1

# on cre une frame sur la dernire ligne avec
#   une tiquette de consigne/controle de la rponse (2e ligne)
frame .cframe -bg $glob(bgcolor)
pack .cframe -side bottom -expand true
label .cframe.control -bg $glob(bgcolor) -font 12x24
pack .cframe.control

##############################################
# ###
# recule
# ###
proc recule {} {
  global difficulte
  if { $difficulte > 0 } {
    incr difficulte -1 
  }
}

# ###
# avance
# ###
proc avance {} {
  global glob didacticiel difficulte

  # dterminer les difficults max

  #lecture du parcours de l'lve
    #lire le fichier utilisateur
    set f [open [file join $glob(trace_user).level] "r"]
    while { ! [eof $f] } {
      set line [gets $f]
      set lt_array([lindex $line 0]) [lrange $line 1 end] 
    }
    close $f
    #traiter le didacticiel
    for {set i 0} {$i <= 4} {incr i 1} {
      set parcours($i) [lindex $lt_array($didacticiel) $i]
    }

  #autoriser/interdire
  for { set i 0 } { $i < 4 } { incr i } {
    set ktmp [expr $parcours($i) + 1]
    if { $ktmp < 4 } {
      set difficulte_max($i) $ktmp
    } else {
      set difficulte_max($i) 4
    }
  }
  if { [expr $parcours(2)+$parcours(3) ] < 4 } {
    set difficulte_max(4) -1
  } else {
    set difficulte_max(4) 4
  }

  if { $difficulte < $difficulte_max(3) } {
    incr difficulte
  }
}

####
# lire le fichier tableau de jeu
####
proc lire_tableau {} {
  global didacticiel taillerect imgperso globcol globrow img1arr img2arr
  set f [open [file join sysdata/3 tableau.jeu] "r"]
  set taillerect [gets $f]
  set imgperso [gets $f]
  set globcol [gets $f]
  for {set i 1} {$i <= $globcol} {incr i 1} {
    set img1arr($i) [gets $f]
  }
  set globrow [gets $f]
  for {set i 1} {$i <= $globrow} {incr i 1} {
    set img2arr($i) [gets $f]
  }
  close $f 
}

####
# permuter les images
####
proc permuter_images {} {
  global imgperso difficulte globcol globrow nbcol nbrow img1arr img2arr
  for {set i 1} {$i <= $globcol} {incr i 1} {
    set imgtmp $img1arr($i)
    set k [expr int(rand()*$globcol)+1]
    set img1arr($i) $img1arr($k)
    set img1arr($k) $imgtmp 
  }
  for {set i 1} {$i <= $globrow} {incr i 1} {
    set imgtmp $img2arr($i)
    set k [expr int(rand()*$globrow)+1]
    set img2arr($i) $img2arr($k)
    set img2arr($k) $imgtmp 
  }
  
  #instancier nbcol et nbrow
  if       { $difficulte == "0" } { 
    set nbrow 3 ; set nbcol 1 
  } elseif { $difficulte == "1" } { 
   set nbrow 1 ; set nbcol 4 
  } elseif { $difficulte == "2" } {
   set nbrow 2 ; set nbcol 2 
  } elseif { $difficulte == "3" } {
   set nbrow 3 ; set nbcol 3 
  } elseif { $difficulte == "4" } {
   set nbrow 3 ; set nbcol 4 
  }

  if {$nbrow> $globrow} {
    set nbrow $globrow
  }
  if {$nbcol> $globcol} {
    set nbcol $globcol
  }
}

# ##
# sauver trace-lve et parcours
# ##
proc sauver_trace_parcours {} {
  global glob didacticiel difficulte nbessais nbquestions nbjustes heure_debut

  ## trace
  # utilisateur/classe/date/dure/didacticiel/niveau/difficulte/version/nbjustes/nbquestions
  set eleve [lindex [split $glob(trace_user) /] end]
  if { $glob(platform) == "unix" } {
    set heure_fin [clock clicks -milliseconds]
    set duree [expr abs(int($heure_debut-$heure_fin)/1000)]
    set date_heure [clock format [clock seconds] -format "%c"]
    set trace_eleve "$eleve classe \{$date_heure\} $duree \{$didacticiel 3 $difficulte\} $glob(version)"
  } else {
    set trace_eleve "$eleve classe \{Ddd Mmm  99 00:00:00 9999\} 0 \{$didacticiel 3 $difficulte\} $glob(version)"
  }

  lappend trace_eleve "$nbjustes $nbquestions"

  set f [open [file join $glob(trace_user).log] "a+"]
  puts $f $trace_eleve
  close $f

  ## parcours
  # bug Tcl/Tk ? Ne peut utiliser w+. Ouvrir r puis w et renommer
  #lire les parcours en lecture
  set lt_array($didacticiel) "-1 -1 -1 -1 -1" ;#sentinelle
  set f [open [file join $glob(trace_user).level] "r"]
  while { ! [eof $f] } {
    set line [gets $f]
    set lt_array([lindex $line 0]) [lrange $line 1 end]
  }
  close $f

  set parcours [lindex $lt_array($didacticiel) 3]

  #parcours suffisant ? Tolrance : 0 ou 1 erreur
  if { $parcours < $difficulte && $nbjustes >= 5 } {
    set lt_array($didacticiel) [lreplace $lt_array($didacticiel) 3 3 $difficulte]
    #sauver dans fichier temporaire
    set f [open [file join $glob(trace_user).tmp] "w"]
    foreach local_didacticiel [array names lt_array] {
      puts $f "$local_didacticiel $lt_array($local_didacticiel)"
    }
    close $f
    #renommer
    file rename -force $glob(trace_user).tmp $glob(trace_user).level 
  }
}

proc commence {c} {
  global glob didacticiel difficulte nbquestions nbjustes iquestion nbessai heure_debut
# set nbessai 0
  set iquestion 0
  set nbjustes 0

  wm title . "$didacticiel $difficulte"
  for {set i 1} {$i <= $nbquestions} {incr i 1} {
    .bframe.lab$i configure -image pneutre -width 40 
  }

  permuter_images
  if { $glob(platform) == "unix" } {
    set heure_debut [clock clicks -milliseconds]
  } else {
    set heure_debut 0
  }

  main $c
}

#########################################################################################
#procdure principale, charge de reboucler, appele depuis le bouton 'continuer'

proc main {c} {
########################Initialisation de variables###############################
# nbcol : nombre de colonnes du tableau
# nbrow : nombre de lignes 
# taillerect : taille d'une cellule du tableau
# on peut modifier le nb de lignes ou de colonnes du tableau, en tenant compte de la taille de la fentre
# en jouant sur la taille des cellules, en redimensionnant les images, en crant d'autres images
# si l'on cre d'autres lignes ou colonnes
# indice1 et indice2 : numro des habits tirs au hasard
# nbessai : 1 ou 2 essais pour rpondre
# on rcupre les params du fichier tableau.jeu, on le mmorise dans les variables imgperso, img1arr, img2arr
# respectivement le personnage, les images de la ligne, de la colonne d'entte

global glob didacticiel nbcol nbrow taillerect indice1 indice2 nbessai iquestion \
	img1arr img2arr imgperso

set nbessai 0
incr iquestion

# On dsactive le bouton 'continuer' et on affiche la consigne
.bframe.next configure -state disabled
.cframe.control configure -text [mc move_syllabus]
grid .cframe.control

# on efface la grille
$c delete all

####################Cration du tableau###################################
# On utilise des rectangles pour dessiner les cases, on aurait pu utiliser des lignes
# De mme, on aurait pu utiliser le 'grid manager' pour grer le tout, mais c'aurait t peut tre
# un peu plus compliqu. L'avantage des rectangles, c'est qu'ils peuvent constituer des objets
# indpendants, utile si on veut leur associer des comportements

for {set i 0} {$i <= [expr $nbcol]} {incr i 1} {
  for {set j 0} {$j <= [expr $nbrow]} {incr j 1} {
    $c create rect [expr $glob(org) + $i*$taillerect] [expr $glob(org) + $j*$taillerect ]  [expr $glob(org) + ($i+1)*$taillerect]  [expr $glob(org) + ($j+1)*$taillerect]  -width 2 -fill gray -tags rect$i$j
  }
}

##################### placement des images de la ligne 0 et de la colonne 0########

for {set i 1} {$i <= $nbcol} {incr i 1} {
  $c create image [expr $glob(org) + $i*$taillerect + int($taillerect/2)] [expr $glob(org) + int($taillerect/2) ] -image [image create photo -file [file join sysdata/3 $img1arr($i)]]
}

for {set j 1} {$j <= $nbrow} {incr j 1} {
  $c create image [expr $glob(org) + int($taillerect/2) ] [expr $glob(org) + $j*$taillerect + int($taillerect/2)] -image [image create photo -file [file join sysdata/3 $img2arr($j)]]
}

# fond clignotant dans la case (0,0)
  $c create image [expr $glob(org) + int($taillerect/2)] [expr $glob(org) + int($taillerect/2)] \
	-image [image create photo -file [file join sysdata cellule00.gif]]

####################Cration du personnage#####################
# Nous ne sommes pas limits  ce genre de situations : on peut trs bien crer
# des images reprsentant des lettres ou des syllabes ...
# Initialisation de 2 variables alatoires pour le choix de la tenue vestimentaire

set indice1 [expr int(rand()*$nbcol) + 1]
set indice2 [expr int(rand()*$nbrow) + 1]

# Pour crer le forme, on est oblig d'utiliser une astuce,  cause d'un 
# dfaut de gestion des images dans tcl/tk.
# Normalement, on cre en mmoire une image et l'on 'superpose' dessus 3 fichiers images 
# dans un format .gif ou .png pour bnficier de la transparence, de manire  obtenir un seul objet
# Dans notre cas, on crera 3 images diffrentes que l'on superpose, 
# mais on devra bouger les 3 images pour dplacer le personnage.

# A chacune des 3 images, on associe le tag 'lap' permettant de les reconnatre plus tard
# pour les dplacer. A la dernire image, on rajoute le tag 'drag', qui permettra de recevoir
# les vnements pour le dplacement

image create photo forme
$c create image 60 60 -image forme -tags lap
forme read [file join sysdata/3 $imgperso]
image create photo chemise
$c create image 60 60 -image chemise -tags lap
chemise read [file join sysdata/3 $img1arr($indice1)]
image create photo pantalon
$c create image 60 60 -image pantalon -tags drag
pantalon read [file join sysdata/3 $img2arr($indice2)]
$c addtag lap withtag drag


#####################################Gestion des vnements############################
# On associe la gestion des dplacements avec l'item portant le tag 'drag'
# c'est  dire le personnage (ou plus exactement la troisime image du personnage
# les 2 autres devant tre synchronises
# %x %y rcuprent la position de la souris.  

$c bind drag <ButtonRelease-1> "itemStopDrag $c %x %y"
$c bind drag <1> "itemStartDrag $c %x %y"
$c bind drag <B1-Motion> "itemDrag $c %x %y"
bind . <Destroy> "exit"

}

# procdure appele depuis 'Itemstopdrag' pour mettre en surbrillance les cellules
#  l'issue de la correction
     
proc highlight { c indice1 indice2} {
    for {set i 0} {$i < [expr $indice1]} {incr i 1} {
        $c itemconfigure rect$i$indice2 -fill pink
    }
    for {set i 0} {$i < [expr $indice2]} {incr i 1} {
        $c itemconfigure rect$indice1$i -fill pink
    }
    $c itemconfigure rect$indice1$indice2 -fill purple
}

# ############################Lorsque l'on clique sur le personnage (bouton appuy)
# On capture la position de la souris dans les variables lastX et lastY
# de mme que les coordonnes du personnage 'sourcecoord'

proc itemStartDrag {c x y} {
    global lastX lastY sourcecoord
    set sourcecoord [$c coords current]
    set lastX [$c canvasx $x]
    set lastY [$c canvasy $y]

    . config -cursor fleur
    
}

# #########################On relche la souris.
# C'est ici que l'on fait le traitement et l'analyse de la position du personnage
# Lorsque le traitement sera plus importants, on pourra crer une ou plusieurs procdures
# supplmentaires pour grer les essais, les erreurs, le rebouclage etc..

proc itemStopDrag {c x y} {
  global glob didacticiel taillerect nbrow nbcol sourcecoord indice1 indice2 nbessai iquestion nbquestions nbjustes
  incr nbessai

  . config -cursor left_ptr

  set coord [$c coords current]
  # On calcule le numro de la case o se trouve le personnage (xc et yc)
  set xc [expr int([lindex $coord 0]/$taillerect)]
  set yc [expr int([lindex $coord 1]/$taillerect)]
  # On teste si le personnage est dans une case valide

  if {$xc>0 && $xc<=$nbcol && $yc>0 && $yc<=$nbrow} {
    # Si oui, on dplace le personnage             
    foreach i [$c find withtag lap] { 
      $c coords $i [expr $xc*$taillerect + int($taillerect/2)] [expr $yc*$taillerect + int($taillerect/2)]
    }
    if {$xc==$indice1 && $yc==$indice2} {
      set str [mc win]
      incr nbjustes
      $c create image [expr $xc*$taillerect + int($taillerect/2)] \
			[expr $yc*$taillerect + int($taillerect/2) ] \
			-image [image create photo -file [file join sysdata bien.gif]]
      if { $nbessai <2 } {
        .bframe.lab$iquestion configure -image pbien -width 40
      } else {
        .bframe.lab$iquestion configure -image ppass -width 40
      }
      if {$iquestion >= $nbquestions} {
        #################################################
        ####ajouter ici le code de sortie
        sauver_trace_parcours

        .bframe.next configure -state normal
        .cframe.control configure -text "Score $nbjustes/$nbquestions. [mc theend]"
        grid .cframe.control -padx 64 

        $c create image [expr int($glob(width)/2)] [expr int($glob(height)/2)] -image gros$didacticiel

        return
        ############################################"
      }
      # on reactive le bouton 'continuer'
      $c itemconf [$c find withtag drag] -tag dead
      #.bframe.next configure -state normal
      .cframe.control configure -text $str
      update
      after 2000
      main $c
    } else {
      # gestion des erreurs
      switch $nbessai {
        1 { set str [mc redo]
            $c create image [expr $xc*$taillerect + int($taillerect/2)] \
			[expr $yc*$taillerect + int($taillerect/2) ] \
			-image [image create photo -file [file join sysdata mal.gif]]
            foreach i [$c find withtag lap] {
              $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
            }
           .cframe.control configure -text $str
          }
        2 {
            # On positionne correctement le personnage
            foreach i [$c find withtag lap] {
              $c coords $i [expr $xc*$taillerect + int($taillerect/2)] [expr $yc*$taillerect + int($taillerect/2)]
            }
            # on met la figure mal dans la mauvaise case qui a t choisie
            $c create image [expr $xc*$taillerect + int($taillerect/2)] \
			[expr $yc*$taillerect + int($taillerect/2) ] \
			-image [image create photo -file [file join sysdata mal.gif]]
            # On met en surbrillance les cellules
            highlight $c $indice1 $indice2
            update
            # on dplace le personnage  la bonne cellule
            set str [mc lose]
            foreach i [$c find withtag lap] { 
              $c coords $i [expr $indice1*$taillerect + int($taillerect/2)] [expr $indice2*$taillerect + int($taillerect/2)]
            }
            .bframe.lab$iquestion configure -image pmal -width 40
            $c itemconf [$c find withtag drag] -tag dead

            if {$iquestion >= $nbquestions} {
              #################################################
              ####ajouter ici le code de sortie
              sauver_trace_parcours

              .cframe.control configure -text "Score $nbjustes/$nbquestions. [mc theend]"
              grid .cframe.control -padx 64 
              # on reactive le bouton 'continuer'
              $c itemconf [$c find withtag drag] -tag dead
              .bframe.next configure -state normal
        $c create image [expr int($glob(width)/2)] [expr int($glob(height)/2)] -image gros$didacticiel
              return
              ############################################"
            }

            .cframe.control configure -text $str
            update
            after 2000
            main $c
          }
      }
    }
    return
  } else {
    # Si non, le personnage n'est pas dans une case valide, on le renvoie  sa place                 
    foreach i [$c find withtag lap] {
      $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
    }
  }
}

# ##################Dplacement du personnage, on gre les coordonnes, toujours avec lastX et lastY
proc itemDrag {c x y} {
  global lastX lastY
  set x [$c canvasx $x]
  set y [$c canvasy $y]
  # On deplace tous les objets possdant le tag 'lap', c'est  dire les 3 images du personnage
  $c move lap [expr $x-$lastX] [expr $y-$lastY]
  set lastX $x
  set lastY $y
}

##################################################################"
# appel de la procdure principale
lire_tableau
commence $c
