#!/bin/sh
#tableaux.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Andr Connes <davidlucardi@aol.com>
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : tableaux.tcl
#  Author  : Andr Connes <andre.connes@toulouse.iufm.fr>
#  Modifier:
#  Date    : 15/04/2003 Modifi le 05/08/2003
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    $Id$
#  @author     Andr Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Andr Connes
# 
#***********************************************************************
global sysFont
source tableaux.conf
source msg.tcl
source fonts.tcl

#wm resizable . 0 0
. configure -background blue
wm geometry . +0+0
wm title . [mc {title_m}]
frame .frame -background blue -height 300 -width 200
pack .frame -side top -fill both -expand yes

if {![file exists [file join $glob(home_tableaux)]]} {
	file mkdir [file join $glob(home_tableaux)]
	file copy -force [file join Reglages] [file join $glob(home_tableaux)]
}

if {![file exists [file join  $glob(trace_dir)]]} {
	file mkdir [file join  $glob(trace_dir)]
}

proc forcer_nom {} {
  global glob
  set w [toplevel .wnom -borderwidth 10]
  wm geometry $w +200+300
  message $w.message -text [mc {donner_nom}]
  entry $w.entry -textvariable glob(win_nom)
  button $w.ok -text Ok -command { set glob(ok) 1 }
  pack $w.message $w.entry $w.ok -side top -fill x

  bind .wnom <Return> { set glob(ok) 1 }

  focus $w.entry
  grab $w
  tkwait variable glob(ok)
  grab release $w
  destroy $w
  if { $glob(ok) } {
    set glob(trace_user) "$glob(trace_dir)/$glob(win_nom)"
  }
}

if { $glob(platform) == "windows" } {
  forcer_nom ;# forcer la lecture de glob(trace_user)
  # sauver trace_user
  set f [open [file join $glob(home_tableaux) Reglages trace_user] "w"]
  puts $f $glob(trace_user)
  close $f
}

#si le fichier utilisateur n'existe pas, le crer !
if { ![file exists $glob(trace_user).level] } {
	set f [open [file join $glob(trace_user).level] "w"]
	foreach  local_didacticiel $glob(didacticiels) {
		puts $f "$local_didacticiel -1 -1 -1 -1 -1"
	}
	close $f
}

if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets"
}

proc showaide {signet} {
  catch {
    option add *textBackground seashell

    set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
  }
}

bind . <F1> "showaide aide"

set didacticiel ""
set forms ""

###########################################################################################""
proc interface {} {
  global sysFont glob

  #########################
  # 	Barre de menus	#
  #-----------------------#

  # Creation du menu utilise comme barre de menu:
  catch {destroy .menu}
  catch {destroy .frame}
  #catch {destroy .wcenter}
  #catch {destroy .wright}

  menu .menu -tearoff 0

  # Creation du menu Fichier
  menu .menu.fichier -tearoff 0
  .menu add cascade -label [mc {Fichier}] -menu .menu.fichier
  .menu.fichier add command -label [mc {Quitter  Ctrl-Q}] -command exit

  # Cration du menu Activits
  menu .menu.action -tearoff 0
  .menu add cascade -label [mc {Activits}] -menu .menu.action
  foreach didacticiel $glob(didacticiels) {
    .menu.action add command -label $didacticiel -command "lanceappli tableau.tcl $didacticiel"
  }

  # Cration du menu Aide
  .menu add command -label [mc {Aide}] -command "showaide aide"

  . configure -menu .menu

  #######################################################################"
  . configure -background blue
  frame .frame -background blue -height 300 -width 200
  pack .frame -side top -fill both -expand yes

  ###################On cre un canvas####################################

  set c .frame.c
  canvas $c -width $glob(width) -height $glob(height) -bg blue -highlightbackground blue
  pack $c -expand true 

  set nl 0
  set nc 0
  foreach didacticiel $glob(didacticiels) {
    button $c.$didacticiel \
	-image [image create photo -file [file join $didacticiel ${didacticiel}_logo.gif]] \
	-borderwidth 10 -cursor heart \
	-command "lanceappli tableau.tcl $didacticiel"
    grid $c.$didacticiel -column $nc -row $nl -sticky e -padx 10 -pady 10
    # dterminer ligne/colonne du bouton suivant
    if { $nl > 1 } {
      incr nc
      set nl 0
    } else {
      incr nl
    }

  }

  button $c.quitter \
	-image [image create photo -file [file join sysdata quitter.gif]] \
	-borderwidth 10 -cursor heart \
	-command exit
  grid $c.quitter -column 2 -row 2 -sticky e -padx 10 -pady 10

  set myimage [image create photo -file sysdata/background.gif]
  label $c.imagedisplayer -image $myimage -background blue
  grid $c.imagedisplayer -column 2 -row 1 -sticky e

}
############
# Bindings #
############
bind . <Control-q> {exit}

# clic droit pour le bilan
bind . <3> "exec wish bilan.tcl"

proc lanceappli {appli niveau} {
  set id_appli [file join $appli]
  exec wish $id_appli $niveau &
}

interface

